Connector interaction in JavaScript Diagram

Connectors can be selected, dragged, and routed over the diagram page.

Select and unSelect connector.

A connector can be selected, simply just by clicking on it.

A connector can be selected at runtime by using the Select method and clear the selection in the diagram using the ClearSelection. The following code explains how to select and clear selection in the diagram.

var connectors = [
    {
      id: 'connector1',
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
        strokeWidth: 2,
      },
      targetDecorator: {
        style: {
          fill: '#6BA5D7',
          strokeColor: '#6BA5D7',
        },
      },
      sourcePoint: {
        x: 100,
        y: 100,
      },
      targetPoint: {
        x: 200,
        y: 200,
      },
    },
  ];
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      connectors: connectors,
    },
    '#element'
  );
  
  document.getElementById('select').onclick = () => {
    diagram.select([diagram.connectors[0]]);
  };
  document.getElementById('unSelect').onclick = () => {
    diagram.clearSelection();
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" id="select" value="select" />
        <input type="button" id="unSelect" value="unSelect" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Drag Connector

Connector can be dragged by just clicking on the connector and dragging.

Connector Drag Gif

A connector can be dragged at runtime by using the Drag method. The following code explains how to drag the connector by using the drag method.

var connectors = [
    {
      id: 'connector1',
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
        strokeWidth: 2,
      },
      targetDecorator: {
        style: {
          fill: '#6BA5D7',
          strokeColor: '#6BA5D7',
        },
      },
      sourcePoint: {
        x: 100,
        y: 100,
      },
      targetPoint: {
        x: 200,
        y: 200,
      },
    },
  ];
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      connectors: connectors,
    },
    '#element'
  );
  
  document.getElementById('drag').onclick = () => {
    let connector = diagram.connectors[0];
    diagram.drag(connector, 20, 20);
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" id="drag" value="drag" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

End point dragging

The connector can be selected by clicking it. When the connector is selected, circles will be added on the starting and ending of the connector that is represented by Thumbs. Clicking and dragging those handles helps you to adjust the source and target points.

End Point drag GIF

You can also update the endPoints of diagram by using dragSourceEnd and dragTargetEnd methods of diagram.

The following code example shows the ways to drag connector end point at runtime.

var connectors = [
    {
      id: 'connector1',
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
        strokeWidth: 2,
      },
      targetDecorator: {
        style: {
          fill: '#6BA5D7',
          strokeColor: '#6BA5D7',
        },
      },
      sourcePoint: {
        x: 100,
        y: 100,
      },
      targetPoint: {
        x: 200,
        y: 200,
      },
    },
  ];
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      connectors: connectors,
    },
    '#element'
  );
  
  document.getElementById('sourcePoint').onclick = () => {
    let connector = diagram.connectors[0];
    connector.sourcePoint = { x: 300, y: 100 };
    diagram.dataBind();
  };
  document.getElementById('targetPoint').onclick = () => {
    let connector = diagram.connectors[0];
    connector.targetPoint = { x: 300, y: 200 };
    diagram.dataBind();
  };
  
  document.getElementById('dragSourceEnd').onclick = () => {
    /**
     * parameter 1 - connector whose source point needs to be moved.
     * parameter 2 - A number representing the horizontal distance by which the source point should be moved.
     * parameter 3 - A number representing the vertical distance by which the source point should be moved.
     */
    diagram.dragSourceEnd(diagram.connectors[0], 50, 50);
  };
  
  document.getElementById('dragTargetEnd').onclick = () => {
    /**
     * parameter 1 - connector whose target point needs to be moved.
     * parameter 2 - A number representing the horizontal distance by which the target point should be moved.
     * parameter 3 - A number representing the vertical distance by which the target point should be moved.
     */
    diagram.dragTargetEnd(diagram.connectors[0], 50, 50);
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" id="sourcePoint" value="sourcePoint" />
        <input type="button" id="targetPoint" value="targetPoint" />
        <input type="button" value="dragSourceEnd" id="dragSourceEnd" />
        <input type="button" value="dragTargetEnd" id="dragTargetEnd" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Segment editing

Diagram allows you to edit connector segments at runtime. To enable this feature, you need to activate the DragSegmentThumb constraint for the connector.

{
connector.constraints =
      ej.diagrams.ConnectorConstraints.Default | ej.diagrams.ConnectorConstraints.DragSegmentThumb;
}

NOTE

To edit a connector segment, you need to inject the ConnectorEditing module into the diagram.

Connector segmnet edit

Flip

The diagram Provides support to flip the connector. The flip is performed to give the mirrored image of the original element.

The flip types are as follows:

  • HorizontalFlip
    Horizontal is used to interchange the connector source and target x points.

  • VerticalFlip
    Vertical is used to interchange the connector source and target y points.

  • Both
    Both is used to interchange the source point as target point and target point as source point
    .

var connectors = [
    {
      id: 'connector1',
      //Flip
      flip: 'Horizontal',
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
        strokeWidth: 2,
      },
      targetDecorator: {
        style: {
          fill: '#6BA5D7',
          strokeColor: '#6BA5D7',
        },
      },
      annotations: [{ content: 'Horizontal Flip' }],
      sourcePoint: { x: 100, y: 100 },
      targetPoint: { x: 200, y: 200 },
    },
    {
      id: 'connector2',
      //Flip
      flip: 'Vertical',
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
        strokeWidth: 2,
      },
      targetDecorator: {
        style: {
          fill: '#6BA5D7',
          strokeColor: '#6BA5D7',
        },
      },
      annotations: [{ content: 'Vertical Flip' }],
      sourcePoint: { x: 300, y: 100 },
      targetPoint: { x: 400, y: 200 },
    },
    {
      id: 'connector3',
      //Flip
      flip: 'Both',
      style: {
        strokeColor: '#6BA5D7',
        fill: '#6BA5D7',
        strokeWidth: 2,
      },
      targetDecorator: {
        style: {
          fill: '#6BA5D7',
          strokeColor: '#6BA5D7',
        },
      },
      annotations: [{ content: 'Both Flip' }],
      sourcePoint: { x: 500, y: 100 },
      targetPoint: { x: 600, y: 200 },
    },
  ];
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '350px',
      getNodeDefaults: function (node) {
        node.height = 100;
        node.width = 100;
        node.style.fill = '#6BA5D7';
        node.style.strokeColor = 'white';
        return node;
      },
      connectors: connectors,
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

NOTE

The flip is not applicable when the connectors connect in nodes

Connector Interaction in Angular Diagram Component

Connectors in the Angular Diagram component support various interaction capabilities including selection, dragging, endpoint manipulation, segment editing, and flipping operations. These interactions enable users to dynamically modify connector behavior and appearance within the diagram.

Select and unselect connector

A connector can be selected by clicking on it. This selection enables further operations such as dragging, editing, or applying transformations.

Connectors can be selected programmatically at runtime using the select method and selection can be cleared using the clearSelection method. The following code demonstrates how to select and clear selection in the diagram.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, ConnectorModel, DecoratorModel, PointModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],

    providers: [],
    standalone: true,
    selector: "app-container",
    template: `
    <input type="button" id="select" value="select" (click)="select()" />
  <input type="button" id="unSelect" value="unSelect" (click)='unSelect()'/>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" >
            <e-connectors>
                <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [targetDecorator]='targetDecorator'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public sourcePoint?: PointModel;
    public targetPoint?: PointModel;
    public targetDecorator?: DecoratorModel;

    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
    };

    public select(): void {
        if (this.diagram) {
            this.diagram.select([this.diagram.connectors[0]]);
        }
    };

    public unSelect(): void {
        if (this.diagram) {
            this.diagram.clearSelection();
        };
    };
};
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Drag connector

Connectors can be repositioned by clicking and dragging them to a new location within the diagram canvas.

Connector Drag Animation

A connector can be dragged programmatically at runtime using the drag method. The following code demonstrates how to drag a connector using the drag method.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, DecoratorModel, PointModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <input type="button" id="drag" value="Drag" (click)="drag()" />
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" >
            <e-connectors>
                <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [targetDecorator]='targetDecorator'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public sourcePoint?: PointModel;
    public targetPoint?: PointModel;
    public targetDecorator?: DecoratorModel;

    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };

    };
    public drag(): void {
        if (this.diagram) {
            let connector = this.diagram.connectors[0];
            this.diagram.drag(connector, 20, 20);
        };
    };
};
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Endpoint dragging

When a connector is selected, circular handles (thumbs) appear at the source and target endpoints. These handles allow users to adjust the connector’s start and end positions by clicking and dragging them.

End Point Drag Animation

The end points of connectors can also be updated programmatically using the dragSourceEnd and dragTargetEnd methods of the diagram component.

The following code example demonstrates how to drag connector end points at runtime.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, DecoratorModel, PointModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [DiagramModule],

    providers: [],
    standalone: true,
    selector: 'app-container',
    template: `
    <input type="button" id="sourcepoint" value="SourcePoint" (click)="sourcePointDrag()" />
    <input type="button" id="targetpoint" value="TargetPoint" (click)="targetPointDrag()" />
    <input type="button" id="dragTargetEnd" value="dragTargetEnd" (click)="dragTargetEnd()" />
    <input type="button" id="dragSourceEnd" value="dragSourceEnd" (click)="dragSourceEnd()" />
 
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" >
            <e-connectors>
                <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [targetDecorator]='targetDecorator'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>

    `,
    encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;
    public sourcePoint?: PointModel;
    public targetPoint?: PointModel;
    public targetDecorator?: DecoratorModel;

    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
    };

    public sourcePointDrag(): void {
        if (this.diagram) {
            let connector = this.diagram.connectors[0];
            connector.sourcePoint = { x: 300, y: 100 };
        };
    };

    public targetPointDrag(): void {
        if (this.diagram) {
            let connector = this.diagram.connectors[0];
            connector.targetPoint = { x: 300, y: 200 };
        };
    };
    public dragSourceEnd():void{
            /**
     * parameter 1 - connector whose source point needs to be moved.
     * parameter 2 - A number representing the horizontal distance by which the source point should be moved.
     * parameter 3 - A number representing the vertical distance by which the source point should be moved.
     */
      (this.diagram as any).dragSourceEnd((this.diagram as any).connectors[0], 50, 50);
    }
    public dragTargetEnd():void{
          /**
     * parameter 1 - connector whose target point needs to be moved.
     * parameter 2 - A number representing the horizontal distance by which the target point should be moved.
     * parameter 3 - A number representing the vertical distance by which the target point should be moved.
     */
           (this.diagram as any).dragTargetEnd( (this.diagram as any).connectors[0], 50, 50);
    }
};
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Segment editing

The diagram allows editing of individual connector segments at runtime. To enable this feature, activate the DragSegmentThumb constraint for the connector.

connector.constraints = 
    ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb;

NOTE

To edit connector segments, you must inject the ConnectorEditing module into the diagram’s providers.

Connector Segment Editing Animation

Flip

The diagram provides support for flipping connectors to create mirrored versions of the original element. The flip operation transforms the connector based on the specified flip direction.

The available flip types are:

  • Horizontal Flip - Flips the connector horizontally across a central vertical axis, creating a mirror image.

  • Vertical Flip - Flips the connector vertically across a central horizontal axis.

  • Both - Reverses the connector’s direction by swapping its source and target points.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { DiagramModule } from '@syncfusion/ej2-angular-diagrams';



import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, ConnectorModel, PointModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [ ],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" >
        <e-connectors>
        <e-connector id='connector1' type='Straight' flip='Horizontal'[sourcePoint]='sourcePoint1' [targetPoint]='targetPoint1' >
            <e-connector-annotations>
                    <e-connector-annotation content="Horizontal Flip">
                    </e-connector-annotation>
                </e-connector-annotations>
            </e-connector>
        
            <e-connector id='connector2' type='Straight' flip='Vertical' [sourcePoint]='sourcePoint2' [targetPoint]='targetPoint2' >
            <e-connector-annotations>
                    <e-connector-annotation content="Vertical Flip">
                    </e-connector-annotation>
                </e-connector-annotations>
            </e-connector>
       
            <e-connector id='connector3' type='Straight' flip='Both' [sourcePoint]='sourcePoint3' [targetPoint]='targetPoint3'>
            <e-connector-annotations>
                    <e-connector-annotation content="Both Flip">
                    </e-connector-annotation>
                </e-connector-annotations>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public sourcePoint1?: PointModel;
    public targetPoint1?: PointModel;
    public sourcePoint2?: PointModel;
    public targetPoint2?: PointModel;
    public sourcePoint3?: PointModel;
    public targetPoint3?: PointModel;
    ngOnInit(): void {
        this.sourcePoint1 = { x: 100, y: 100 };
        this.targetPoint1 = { x: 200, y: 200 };
        this.sourcePoint2 = { x: 300, y: 100 };
        this.targetPoint2 = { x: 400, y: 200 };
        this.sourcePoint3 = { x: 500, y: 100 };
        this.targetPoint3 = { x: 600, y: 200 };
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Note: The flip operation is not applicable when connectors are connected to nodes.

Connector interaction in Vue Diagram

Connectors can be selected, dragged, and routed over the Vue Diagram page.

Select and unSelect connector.

A connector can be selected, simply just by clicking on it.

A connector can be selected at runtime by using the Select method and clear the selection in the diagram using the ClearSelection. The following code explains how to select and clear selection in the diagram.

<template>
    <div id="app">
        <button @click="select">select</button>
        <button @click="unselect">unselect</button>
        <ejs-diagram ref="diagram" id="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const connectors = [{
    // Name of the connector
    id: "connector1",
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
}
]
const width = "100%";
const height = "350px";
const select = function () {
     const diagramInstance = diagram.value.ej2Instances;
    diagramInstance.select([diagramInstance.connectors[0]]);
}
const unselect = function () {
       const diagramInstance = diagram.value.ej2Instances;
   diagram.value.ej2Instances.clearSelection();
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
<button @click="select">select</button>
<button @click="unselect">unselect</button>
    <ejs-diagram ref="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

const connectors = [{
// Name of the connector
id: "connector1",
sourcePoint: {
  x: 100,
  y: 100,
},
targetPoint: {
  x: 200,
  y: 200,
},
}
]
export default {
name: "App",
components: {
    "ejs-diagram": DiagramComponent
},
data() {
    return {
        width: "100%",
        height: "350px",
        connectors: connectors
    }
},methods: {
  select() {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    diagramInstance.select([diagramInstance.connectors[0]]);
  },
  unselect() {
      // remove connector from the diagram
      this.$refs.diagram.ej2Instances.clearSelection();
  },
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Drag Connector

Connector can be dragged by just clicking on the connector and dragging.

Connector Drag Gif

A connector can be dragged at runtime by using the Drag method. The following code explains how to drag the connector by using the drag method.

<template>
    <div id="app">
        <button @click="drag">drag</button>
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const connectors = [{
    // Name of the connector
    id: "connector1",
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    
}
]
const width = "100%";
const height = "350px";
const drag = function () {
      const diagramInstance = diagram.value.ej2Instances;
     let connector= diagramInstance.connectors[0];
     diagramInstance.drag(connector, 20, 20);
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
<button @click="drag">drag</button>
    <ejs-diagram ref="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

const connectors = [{
// Name of the connector
id: "connector1",
sourcePoint: {
    x: 100,
    y: 100
},
targetPoint: {
    x: 200,
    y: 200
},
}
]
export default {
name: "App",
components: {
    "ejs-diagram": DiagramComponent
},
data() {
    return {
        width: "100%",
        height: "350px",
        connectors: connectors
    }
},
methods: {
  drag() {
    const diagramInstance = this.$refs.diagram.ej2Instances;
     let connector= diagramInstance.connectors[0];
     diagramInstance.drag(connector, 20, 20);
  },}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

End point dragging

The connector can be selected by clicking it. When the connector is selected, circles will be added on the starting and ending of the connector that is represented by Thumbs. Clicking and dragging those handles helps you to adjust the source and target points.

End Point drag GIF

You can also update the endPoints of diagram by using dragSourceEnd and dragTargetEnd methods of diagram.

The following code example shows the ways to drag connector end point at runtime.

<template>
<div id="app">
<button @click="sourcePoint">sourcePoint</button>
<button @click="targetPoint">targetPoint</button>
<button @click="dragSourceEnd">dragSourceEnd</button>
<button @click="dragTargetEnd">dragTargetEnd</button>
<ejs-diagram ref="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
</div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const connectors = [{
    // Name of the connector
    id: "connector1",
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
}
]

const width = "100%";
const height = "350px";
 const sourcePoint= function() {
    const diagramInstance = diagram.value.ej2Instances;
    let connector = diagramInstance.connectors[0];
    connector.sourcePoint = {x:300,y:100};
    diagramInstance.dataBind();
  }
  const targetPoint= function() {
    const diagramInstance = diagram.value.ej2Instances;
    let connector = diagramInstance.connectors[0];
    connector.targetPoint = {x:300,y:200};
    diagramInstance.dataBind();
  }
  const dragSourceEnd= function() {
    const diagramInstance = diagram.value.ej2Instances;
    diagramInstance.dragSourceEnd(diagramInstance.connectors[0], 50, 50);
}
 const dragTargetEnd= function() {
  const diagramInstance = diagram.value.ej2Instances;
  diagramInstance.dragTargetEnd(diagramInstance.connectors[0], 50, 50);
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
<button @click="sourcePoint">sourcePoint</button>
<button @click="targetPoint">targetPoint</button>
<button @click="dragSourceEnd">dragSourceEnd</button>
<button @click="dragTargetEnd">dragTargetEnd</button>
    <ejs-diagram ref="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

const connectors = [{
// Name of the connector
id: "connector1",
sourcePoint: {
    x: 100,
    y: 100
},
targetPoint: {
    x: 200,
    y: 200
},
}
]
export default {
name: "App",
components: {
    "ejs-diagram": DiagramComponent
},
data() {
    return {
        width: "100%",
        height: "350px",
        connectors: connectors
    }
},
methods: {
  sourcePoint() {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    let connector = diagramInstance.connectors[0];
    connector.sourcePoint = {x:300,y:100};
    diagramInstance.dataBind();
  },
  targetPoint() {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    let connector = diagramInstance.connectors[0];
    connector.targetPoint = {x:300,y:200};
    diagramInstance.dataBind();
  },
  dragSourceEnd() {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    diagramInstance.dragSourceEnd(diagramInstance.connectors[0], 50, 50);
},
dragTargetEnd() {
  const diagramInstance = this.$refs.diagram.ej2Instances;
  diagramInstance.dragTargetEnd(diagramInstance.connectors[0], 50, 50);
},
  },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Segment editing

Diagram allows you to edit connector segments at runtime. To enable this feature, you need to activate the DragSegmentThumb constraint for the connector.

{
connector.constraints =
      ConnectorConstraints.Default | ConnectorConstraints.DragSegmentThumb;
}

NOTE

To edit a connector segment, you need to inject the ConnectorEditing module into the diagram.

Connector segmnet edit

Flip

The diagram Provides support to flip the connector. The flip is performed to give the mirrored image of the original element.

The flip types are as follows:

  • HorizontalFlip
    Horizontal is used to interchange the connector source and target x points.

  • VerticalFlip
    Vertical is used to interchange the connector source and target y points.

  • Both
    Both is used to interchange the source point as target point and target point as source point

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const connectors = [
{
  id: 'connector1',
  //Flip
  flip: 'Horizontal',
  annotations: [{ content: 'Horizontal Flip' }],
  sourcePoint: { x: 100, y: 100 },
  targetPoint: { x: 200, y: 200 },
},{
  id: 'connector2',
  //Flip
  flip: 'Vertical',
  annotations: [{ content: 'Vertical Flip' }],
  sourcePoint: { x: 300, y: 100 },
  targetPoint: { x: 400, y: 200 },
},  {
  id: 'connector3',
  //Flip
  flip: 'Both',
  annotations: [{ content: 'Both Flip' }],
  sourcePoint: { x: 500, y: 100 },
  targetPoint: { x: 600, y: 200 },
},
]
const width = "100%";
const height = "350px";

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
    <ejs-diagram id="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

const connectors = [
{
  id: 'connector1',
  //Flip
  flip: 'Horizontal',
  annotations: [{ content: 'Horizontal Flip' }],
  sourcePoint: { x: 100, y: 100 },
  targetPoint: { x: 200, y: 200 },
},{
  id: 'connector2',
  //Flip
  flip: 'Vertical',
  annotations: [{ content: 'Vertical Flip' }],
  sourcePoint: { x: 300, y: 100 },
  targetPoint: { x: 400, y: 200 },
},  {
  id: 'connector3',
  //Flip
  flip: 'Both',
  annotations: [{ content: 'Both Flip' }],
  sourcePoint: { x: 500, y: 100 },
  targetPoint: { x: 600, y: 200 },
},
]
export default {
name: "App",
components: {
    "ejs-diagram": DiagramComponent
},
data() {
    return {
        width: "100%",
        height: "350px",
        connectors: connectors
    }
}
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

NOTE

The flip is not applicable when the connectors connect in nodes